<?php declare(strict_types=1);
namespace MyTestNamespace;
require __DIR__ . '/bootstrap.php';
require __DIR__ . '/testClasses.php';
use Grifart\AssertFunction\FunctionSignatureAssertionError;
use Tester\Assert;
use function Grifart\AssertFunction\{
	assertSignature, params
};

$position = 'tests/' . basename(__FILE__) . ':' . (__LINE__ + 2);

$f1 = function(T1 $t1, T2 $t2): T3 {return new T3;};

// Wrong number of arguments
Assert::exception(
	function () use ($f1) {
		assertSignature($f1, params(T1::class), T3::class);
	},
	FunctionSignatureAssertionError::class,
	"$position Wrong number of arguments in given function. Expected 1, 2 given."
);

Assert::exception(
	function () use ($f1) {
		assertSignature($f1, params(T1::class, T2::class, T1::class), T3::class);
	},
	FunctionSignatureAssertionError::class,
	"$position Wrong number of arguments in given function. Expected 3, 2 given."
);
